﻿using C1.Win.C1Editor;
using C1.Win.C1Editor.ToolStrips;
using C1.Win.C1Input;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace C1EditorlimitColors
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            SetForeColorPicker();
            SetBackColorPicker();
            SetParaBackColorPicker();
        }

        private void SetForeColorPicker() {
            ToolStripItem itemForeColor = c1EditorToolStripStyle1.Items[15];
            ToolStripSplitButton foreCombo = new ToolStripSplitButton();
            foreCombo.Name = itemForeColor.Name;
            foreCombo.Text = itemForeColor.Text;
            foreCombo.Image = Properties.Resources.forecolor1;

            c1EditorToolStripStyle1.Items.Remove(itemForeColor);
            c1EditorToolStripStyle1.Items.Insert(15, foreCombo);

            ToolStripItem item = foreCombo.DropDownItems.Add("BLUE");
            item.Image = Properties.Resources.Blue;
            item = foreCombo.DropDownItems.Add("BLACK");
            item.Image = Properties.Resources.Black;
            item = foreCombo.DropDownItems.Add("RED");
            item.Image = Properties.Resources.Red;

            foreCombo.DropDownItemClicked += ForeCombo_DropDownItemClicked;
        }

        private void SetBackColorPicker()
        {
            ToolStripItem itemForeColor = c1EditorToolStripStyle1.Items[16];
            ToolStripSplitButton backCombo = new ToolStripSplitButton();
            backCombo.Name = itemForeColor.Name;
            backCombo.Text = itemForeColor.Text;

            backCombo.Image = Properties.Resources.backcolor;
            c1EditorToolStripStyle1.Items.Remove(itemForeColor);
            c1EditorToolStripStyle1.Items.Insert(16, backCombo);

            ToolStripItem item = backCombo.DropDownItems.Add("BLUE");
            item.Image = Properties.Resources.Blue;
            item = backCombo.DropDownItems.Add("BLACK");
            item.Image = Properties.Resources.Black;
            item = backCombo.DropDownItems.Add("RED");
            item.Image = Properties.Resources.Red;

            backCombo.DropDownItemClicked += BackCombo_DropDownItemClicked;
        }

        private void SetParaBackColorPicker()
        {
            ToolStripItem itemForeColor = c1EditorToolStripStyle1.Items[17];
            ToolStripSplitButton parabackCombo = new ToolStripSplitButton();
            parabackCombo.Name = itemForeColor.Name;
            parabackCombo.Text = itemForeColor.Text;
            parabackCombo.Image = Properties.Resources.paracolor;

            c1EditorToolStripStyle1.Items.Remove(itemForeColor);
            c1EditorToolStripStyle1.Items.Insert(17, parabackCombo);

            ToolStripItem item = parabackCombo.DropDownItems.Add("BLUE");
            item.Image = Properties.Resources.Blue;
            item = parabackCombo.DropDownItems.Add("BLACK");
            item.Image = Properties.Resources.Black;
            item = parabackCombo.DropDownItems.Add("RED");
            item.Image = Properties.Resources.Red;

            parabackCombo.DropDownItemClicked += ParabackCombo_DropDownItemClicked;
        }

        private void ParabackCombo_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            ChangePropertyOfSelection("Background-Color", e.ClickedItem.Text,C1StyleType.Paragraph);

        }

        private void BackCombo_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            ChangePropertyOfSelection("Background-Color", e.ClickedItem.Text, C1StyleType.Character);

        }

        private void ForeCombo_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            ChangePropertyOfSelection("Color", e.ClickedItem.Text);
        }

        private void ChangePropertyOfSelection(string propertyName,string propertyValue, C1StyleType type = C1StyleType.Any ) {
            C1TextRange range = c1Editor1.CreateRange(c1Editor1.SelectionStart, c1Editor1.SelectionLength);
            range.ApplyStyle(propertyName, propertyValue, type);
        }
    }
}
